/*
 * Tabs are 4 symbols wide due to stupid Windows function names...
 * ---------------------------------------------------------------
 *
 * Copyright (c) 2010 KSI Labs, LLC. All rights reserved.
 * Written by Sergey Kubushyn <ksi@koi8.net>, <ksi@ksilabs.com>.
 *
 * File: power.h
 *
 * This is Power Management routines for WDM driver for KSI Labs, LLC
 * CENTIPEDE PCI Board. As a matter of fact all this just a boat anchor
 * because there is absolutely no need for all this most of the times--no
 * one is going to insert/remove a PCI board on a working machine, no one
 * is going to use such a board on a battery-powered laptop, no one is
 * going to powerdown parts of the computer controlling a big dangerous
 * machine--but that is here to comply with braindead Windows concept of
 * "Universal Server of Everything." Most of the code is boilerplate take
 * almost verbatim from DDK examples and don't serve any reasonable purpose.
 *
 * Please read documentation or go to http://www.ksilabs.com for further info.
 */

/*
 * 						LICENSE and Terms of Use.
 *
 * First of all, this is NOT GPL or Free Software. It is open so you have
 * all the source code for the Engine. There is also VHDL source code for
 * CENTIPEDE board CPLD that is available from KSI Labs, LLC website,
 * http://www.ksilabs.com.
 *
 * As for this particular code, Windows Mach3 Engine, you are free to use it,
 * make any modifications to customize it for your own needs, fix inevitable
 * bugs, port it to other CNC software and do anything else as long as your
 * derivative work that is based on this code or uses parts or pieces thereof
 * is made to be used with any KSI Labs, LLC products.
 *
 * We do NOT grant you a permission to use any parts of this software in any
 * products that are designed for products not manufactured or distributed
 * by KSI Labs, LLC. We might give such a permission on case-by-case basis
 * but it is not legal to use this software or bits and pieces thereof with
 * products not coming from KSI Labs, LLC without our explicit written
 * permission.
 *
 * The original copyright notices must be included in all derivative works.
 * You do NOT have to ask our permission to make any modifications to this
 * code and you are not under obligation to give us any of your work back
 * as long as you are using it for your own needs.
 *
 * However we do NOT give our permission to distribute your derivative work
 * unless all original copyrights are retained, all the conditions of this
 * license are met (use only with KSI Labs, LLC products) and full source
 * code for such derivative work is available for free to everybody without
 * any further conditions including but not limited to signing any kinds of
 * NDA. We explicitely deny permission to distribute any derivative work
 * based on this code with closed source binary-only fragments or include
 * bits or pieces of this code in such products.
 *
 * CNC software like Mach3 and likes is excluded from these requirements as
 * long as it does not include parts or pieces of this software into the
 * close source proprietary application proper. It can use shared memory
 * buffer, IOCTL calls, etc. to communicate with this Engine or the one based
 * on it and keep all the software making those calls or working on that
 * buffer close source and proprietary as long as those calls/structures are
 * documented and that documentation is freely available to everybody without
 * any further conditions including but no limited to signing any kind of NDA.
 */

#ifndef __POWER_H
#define __POWER_H

#define MAGIC_NUMBER -1

typedef enum {
	IRP_NEEDS_FORWARDING = 1,
	IRP_ALREADY_FORWARDED
} IRP_DIRECTION;

typedef struct _POWER_COMPLETION_CONTEXT {
	PDEVICE_OBJECT  DeviceObject;
	PIRP            SIrp;
} POWER_COMPLETION_CONTEXT, *PPOWER_COMPLETION_CONTEXT;

NTSTATUS DispatchPower(PDEVICE_OBJECT DeviceObject, PIRP Irp);
NTSTATUS DispatchPowerDefault(PDEVICE_OBJECT DeviceObject, PIRP Irp);
NTSTATUS DispatchSetPowerState(PDEVICE_OBJECT DeviceObject, PIRP Irp);
NTSTATUS DispatchQueryPowerState(PDEVICE_OBJECT DeviceObject, PIRP Irp);
NTSTATUS DispatchSystemPowerIrp(PDEVICE_OBJECT DeviceObject, PIRP Irp);
NTSTATUS CompletionSystemPowerUp(PDEVICE_OBJECT Fdo, PIRP Irp, PVOID NotUsed);
VOID QueueCorrespondingDeviceIrp(PIRP SIrp, PDEVICE_OBJECT DeviceObject);
VOID CompletionOnFinalizedDeviceIrp(PDEVICE_OBJECT DeviceObject, UCHAR MinorFunction,
		POWER_STATE PowerState, PVOID PowerContext, PIO_STATUS_BLOCK IoStatus);
NTSTATUS DispatchDeviceQueryPower(PDEVICE_OBJECT DeviceObject, PIRP Irp);
NTSTATUS DispatchDeviceSetPower(PDEVICE_OBJECT DeviceObject, PIRP Irp);
NTSTATUS CompletionDevicePowerUp(PDEVICE_OBJECT DeviceObject, PIRP Irp, PVOID NotUsed);
NTSTATUS FinalizeDevicePowerIrp(PDEVICE_OBJECT DeviceObject, PIRP Irp,
								IRP_DIRECTION Direction, NTSTATUS Result);
VOID CallbackHandleDeviceQueryPower(PDEVICE_OBJECT DeviceObject,
										PWORK_ITEM_CONTEXT Context);
VOID CallbackHandleDeviceSetPower(PDEVICE_OBJECT DeviceObject,
										PWORK_ITEM_CONTEXT Context);
NTSTATUS PowerBeginQueuingIrps(PDEVICE_OBJECT DeviceObject, ULONG IrpIoCharges,
												BOOLEAN Query);
NTSTATUS GetPowerPoliciesDeviceState(PIRP SIrp, PDEVICE_OBJECT DeviceObject,
										DEVICE_POWER_STATE *DevicePowerState);
NTSTATUS CanSuspendDevice(PDEVICE_OBJECT DeviceObject);

#endif	// __POWER_H
